/**
 * shiftreg.h
 */

#ifndef __WP2016_HW_SHIFTREG_H
#define __WP2016_HW_SHIFTREG_H


#include <stdint.h>


/* hw config */
#include "InitDevice.h" 	// pinouts defined by EFM configurator


/* constants */
#define SR_BITLEN 			16
#define SR_POWER_MASK 		0x8000 	// power pin


/* shiftreg bitfield */
extern uint16_t sr_dat[2];


/* prototypes */
void sr_init();

void sr_send(uint16_t *dat, uint8_t len);
void sr_update();


#endif
