/**
 * the whiskey pirates 2016 keybadge
 * 2016 by anonymous - version 0.0.1
 * this code is a mess of testing shit and is about 10% complete.
 * you are welcome to turn it into something else.
 * you are welcome to give us shit for not having this done.
 * ----
 * completed things:
 * [ ] alarm clocks
 *
 * todo things:
 * [ ] fix alarm clocks won't work because flash is empty
 * [ ] make LED programs
 * [ ] user-settable LED program shit
 * [ ] sync with mainbadge (user's name and last alarm name/time)
 * [ ] make any button do things
 * [ ] credits update
 * [ ] release public windows driver. should work ootb mac/linux/win10
 * [ ] usb msc (readme and windows driver included)
 * [ ] figure out why the badges reset and lose clock, and fix with hot glue :(
 * [ ] move string resources to external flash
 * [ ] finish all usb menus
 * [ ] put placeholder to say the game comes next year
 * [ ] finish the game
 * [ ] apologize profusely
 *
**/

#include "em_device.h"
#include "em_chip.h"
#include "em_cmu.h"
#include "em_emu.h"

#include "InitDevice.h"

#include "hw/adc.h"
#include "hw/osc.h"
#include "hw/lightsense.h"
#include "hw/spiflash.h"
#include "hw/shiftreg.h"
#include "hw/vibrator.h"
#include "hw/userio.h"
#include "usb/usb.h"

#include "console/console.h"

#include "display/led.h"

#include "rtc/alarm.h"
#include "rtc/time.h"



int main(void)
{
	// chip errata fixes
	CHIP_Init();

	// initialize and calibrate clocks, set to default running clockspeed
	// we run at this speed as this will allow a full PWM cycle on the PWM outputs per 2khz tick
	// this call will stall for a bit since the osc will be calibrated
	// actually it won't be calibrated anymore because why was it anyway
	LFXO_enter_DefaultMode_from_RESET();
	osc_init(cmuHFRCOBand_21MHz);

	// start up and configure system peripherals
	CMU_ClockEnable(cmuClock_HFPER, true);
	CMU_ClockDivSet(cmuClock_HFPER, cmuClkDiv_1);
	enter_DefaultMode_from_RESET();

	// initialize console shell
	console_init();

	// initialize external flash
	spiflash_init();
	// and restore settings
	// TODO: fix bug that makes badges actually CRASH when fucking with alarms
	//       as we don't validate flash data being correct...
	alarm_restore_nv();

	// get clock running
	rtc_init();
	rtc_interrupt_enable();

	// set up vibrator
	vibrate_init();

	// set up light sensor
	adc_init();

	// configure system mode based on hardware switch positions
	// also set up the user button hardware
	userio_init();

	// non timing critical tasks and sleep
	while (1) {
		// do console shit if we have a working USB connection
		if (usb_is_configured()) {
			console_process();
		} else {
			console_stop();
		}

		// sleep otherwise, depending on SLEEP switch position
		userio_sleep_enter();
	}
}
