/**
 * console.h
 */

#ifndef __WP2016_COMMS_CONSOLE_TIME_H
#define __WP2016_COMMS_CONSOLE_TIME_H


#include "console.h"

#include "rtc/time.h"
#include "rtc/alarm.h"

#include "hw/spiflash.h"
#include "hw/vibrator.h"


/* prompt */
#define CONS_PROMPT_TIME_ALARM 	"\r\nalarm> "


/* prototypes */
void console_cmd_time_time(int argc, char **argv);
void console_cmd_time_date(int argc, char **argv);
void console_cmd_time_alarm(int argc, char **argv);
void console_cmd_time_alarm_vibrate(int argc, char **argv);

void console_time_alarm_save();


#endif
