/**
 * usbtimer.c
 */

#include "em_device.h"
#include "em_chip.h"
#include "em_cmu.h"

#include "tools.h"
#include "hw/osc.h"


void USBTIMER_Init()
{
	return;
}

static inline void USBTIMER_DelayHalfMs(uint32_t hms)
{
	uint32_t val = 0;

	hms += SysTick->VAL;

	while (val < hms) {
		val = SysTick->VAL;
	}
}

void USBTIMER_DelayMs(uint32_t msec)
{
	USBTIMER_DelayHalfMs(msec << 1);
}

void USBTIMER_DelayUs(uint32_t usec)
{
	uint32_t c;

	c = ((SystemCoreClockGet() / 1000000) * usec) / 2;
	if (c < 20) return;
	c -= 20;
	while (c--);
}
